org.optaplanner.core.impl.score.stream

## Interface InnerConstraintFactory<Solution_>

- All Superinterfaces:
    ConstraintFactory
  All Known Implementing Classes:
    BavetConstraintFactory, DroolsConstraintFactory

      public interface InnerConstraintFactory<Solution_>
      extends ConstraintFactory

- - ### Method Summary

    All Methods Instance Methods Abstract Methods Default Methods
    Modifier and Type | Method and Description
    --- | ---
    `ConstraintSessionFactory<Solution_>` | `buildSessionFactory(Constraint[] constraints)` This method is thread-safe.
    `default <A> UniConstraintStream<A>` | `from(Class<A> fromClass)` Start a `ConstraintStream` of all instances of the fromClass that are known as `problem facts` or `planning entities`.
    `SolutionDescriptor<Solution_>` | `getSolutionDescriptor()`

    - ### Methods inherited from interface org.optaplanner.core.api.score.stream.ConstraintFactory

      `fromUnfiltered, fromUniquePair, fromUniquePair, fromUniquePair, fromUniquePair, fromUniquePair, fromUniquePair, getDefaultConstraintPackage`

- - ### Method Detail

    - #### from

          default <A> UniConstraintStream<A> from(Class<A> fromClass)

      Description copied from interface: `ConstraintFactory`
      Start a `ConstraintStream` of all instances of the fromClass that are known as `problem facts` or `planning entities`.

      If the fromClass is a `PlanningEntity`, then it will be automatically `filtered` to only contain fully initialized entities, for which each genuine `PlanningVariable` (of the fromClass or a superclass thereof) is initialized (so when the value is not null - unless `PlanningVariable.nullable()` is modified). This filtering will NOT automatically apply to genuine planning variables of subclass planning entities of the fromClass.

      Specified by:
        `from` in interface `ConstraintFactory`
      Type Parameters:
        `A` - the type of the matched problem fact or `planning entity`
      Parameters:
        `fromClass` - never null
      Returns:
        never null

    - #### buildSessionFactory

          ConstraintSessionFactory<Solution_> buildSessionFactory(Constraint[] constraints)

      This method is thread-safe.
      Parameters:
        `constraints` - never null
      Returns:
        never null

    - #### getSolutionDescriptor

          SolutionDescriptor<Solution_> getSolutionDescriptor()

      Returns:
        never null

Copyright © 2006–2020 JBoss by Red Hat. All rights reserved.